package probe

import (
	"context"
	"errors"

	"git.loafle.net/overflow/overflow_probes/central/api/module"
	"git.loafle.net/overflow/overflow_probes/commons"
)

type ProbeHandler interface {
	commons.Handler
}

func (p *probe) Serve() error {
	if err := p.connectToCentralProbe(); nil != err {
		return err
	}

	if err := p.collector.Serve(); nil != err {
		return err
	}

	p.sendNotifyToCentral(module.ProbeService_Started)

	var err error
ListenLoop:
	for {
		select {
		case <-p.ShutdownChan:
			err = errors.New("Shutting down")
			break ListenLoop
		}
	}

	p.sendNotifyToCentral(module.ProbeService_Stopped)

	return err
}

func (p *probe) Shutdown(ctx context.Context) error {
	p.ShutdownChan <- true
	return nil
}
